## Ear

### Description

An extension of the Jar task with special treatment for files that should end up in an Enterprise Application archive.

(The Ear task is a shortcut for specifying the particular layout of a EAR file. The same thing can be accomplished by using the prefix and fullpath attributes of zipfilesets in a Zip or Jar task.)

The extended zipfileset element from the zip task (with attributes prefix, fullpath, and src) is available in the Ear task.

Please note that the zip format allows multiple files of the same fully-qualified name to exist within a single archive. This has been documented as causing various problems for unsuspecting users. If you wish to avoid this behavior you must set the `duplicate` attribute to a value other than its default, `"add"`.

### Parameters

Attribute | Description | Required
destfile | the EAR file to create. | Yes
appxml | The deployment descriptor to use (META-INF/application.xml). | Yes, unless update is set to true
basedir | the directory from which to jar the files. | No
compress | Not only store data but also compress them, defaults to true. Unless you set the keepcompression attribute to false, this will apply to the entire archive, not only the files you've added while updating. | No
keepcompression | For entries coming from existing archives (like nested zipfilesets or while updating the archive), keep the compression as it has been originally instead of using the compress attribute. Defaults false. Since Ant 1.6 | No
encoding | The character encoding to use for filenames inside the archive. Defaults to UTF8. It is not recommended to change this value as the created archive will most likely be unreadable for Java otherwise. | No
filesonly | Store only file entries, defaults to false | No
includes | comma- or space-separated list of patterns of files that must be included. All files are included when omitted. | No
includesfile | the name of a file. Each line of this file is taken to be an include pattern | No
excludes | comma- or space-separated list of patterns of files that must be excluded. No files (except default excludes) are excluded when omitted. | No
excludesfile | the name of a file. Each line of this file is taken to be an exclude pattern | No
defaultexcludes | indicates whether default excludes should be used or not ("yes"/"no"). Default excludes are used when omitted. | No
manifest | the manifest file to use. | No
filesetmanifest | behavior when a Manifest is found in a zipfileset or zipgroupfileset file is found. Valid values are "skip", "merge", and "mergewithoutmain". "merge" will merge all of the manifests together, and merge this into any other specified manifests. "mergewithoutmain" merges everything but the Main section of the manifests. Default value is "skip". | No
whenmanifestonly | behavior when no files match. Valid values are "fail", "skip", and "create". Default is "create". | No
manifestencoding | The encoding used to read the JAR manifest, when a manifest file is specified. | No, defaults to the platform encoding.
index | whether to create an index list to speed up classloading. This is a JDK 1.3+ specific feature. Unless you specify additional jars with nested `indexjars` elements, only the contents of this jar will be included in the index. Defaults to false. | No
index | whether to create an index list to speed up classloading. This is a JDK 1.3+ specific feature. Unless you specify additional jars with nested `indexjars` elements, only the contents of this jar will be included in the index. Defaults to false. | No
update | indicates whether to update or overwrite the destination file if it already exists. Default is "false". | No
duplicate | behavior when a duplicate file is found. Valid values are "add", "preserve", and "fail". The default value is "add". | No
roundup | Whether the file modification times will be rounded up to the next even number of seconds. Zip archives store file modification times with a granularity of two seconds, so the times will either be rounded up or down. If you round down, the archive will always seem out-of-date when you rerun the task, so the default is to round up. Rounding up may lead to a different type of problems like JSPs inside a web archive that seem to be slightly more recent than precompiled pages, rendering precompilation useless. Defaults to true. Since Ant 1.6.2 | No
level | Non-default level at which file compression should be performed. Valid values range from 0 (no compression/fastest) to 9 (maximum compression/slowest). Since Ant 1.7 | No

### Nested elements

#### metainf

The nested `metainf` element specifies a FileSet. All files included in this fileset will end up in the `META-INF` directory of the ear file. If this fileset includes a file named `MANIFEST.MF`, the file is ignored and you will get a warning.

#### manifest, indexjars, service

These are inherited from <jar>

## Example

        <ear destfile="build/myapp.ear" appxml="src/metadata/application.xml">
          <fileset dir="build" includes="*.jar,*.war"/>
        </ear>